# Method: customers.userLists.addEventMatchers

- [HTTP request](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists/addEventMatchers#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists/addEventMatchers#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists/addEventMatchers#body.request_body)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists/addEventMatchers#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists/addEventMatchers#body.response_body)
- [Authorization scopes](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists/addEventMatchers#body.aspect)

> [!WARNING]
> Frequency capping audiences are no longer supported in Ads Data Hub due to the upstream [deprecation of frequency-based audiences in Display \& Video 360](https://support.google.com/displayvideo/answer/13439592).

Adds event matchers to a frequency-based user list. This call cannot delete existing event matchers or modify frequency-based constraint metadata such as window or when a user is added. The user list may already contain some event matchers. For example, this call could add: AddEventMatchersRequest { userList: "customers/1/userLists/12345" eventMatchers { matchType: GOOGLE_ADS_CAMPAIGN_ID value: "3456" } } For this call to succeed, user list 12345 should not already contain a campaign constraint of the type GOOGLE_ADS_CAMPAIGN_ID with campaign id "3456".

### HTTP request

`POST https://adsdatahub.googleapis.com/v1/{userList=customers/*/userLists/*}:addEventMatchers`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `userList` | `string` Required. Full resource name, has the form of 'customers/\[customerId\]/userLists/\[userlist_id\]'. UserList must have UserListType FREQUENCY_BASED. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "eventMatchers": [ { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#EventMatcher`) } ] } ``` |

| Fields ||
|---|---|
| `eventMatchers[]` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#EventMatcher`)`` Contain only those constraints to add to the user list. The user list specified by userList should have none of the constraints specified here at the time of the call but can have other pre-existing constraints. |

### Response body

If successful, the response body contains an instance of `https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers.userLists#UserList`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/adsdatahub`